 


		LIST P=16F627
		INCLUDE<P16F627.INC>
		__CONFIG _PWRTE_ON & _WDT_OFF & _MCLRE_OFF & _BODEN_OFF & _LVP_OFF & _HS_OSC


	
TEMP	EQU	23H
TEMP1	EQU	24H
K0L		EQU	25H
K0H		EQU	26H
K1L		EQU	27H
K1H		EQU	28H
TMP0	EQU	29H
TMP1	EQU	30H


		ORG		00H
		GOTO	INIT
;----------------------------------------------------------------------------------------



DELAY5mS		
		MOVLW 0x21  ;33 DEC
        MOVWF TMP1
        MOVLW 0x76  ;118 DEC
        MOVWF TMP0
        DECFSZ TMP0,F
        GOTO $-1
        DECFSZ TMP1,F
        GOTO $-3
		RETURN










;------------------------------------------------------------------------------------------
INIT		
		MOVLW	B'00000111'
		MOVWF	CMCON
		BSF		STATUS,RP0		;BANKA1
				
		MOVLW	B'00000000'		;VYSTUPNI PORT A
		MOVWF	TRISA
		
		MOVLW	B'00000110'		;REZERVACE PORTU B,1,2 PRO SERIOVY PRENOS
		MOVWF	TRISB
		CLRF	PORTB
		
		MOVLW	D'129'			;KONSTANTA PRO VYPOCET BAUD RATE
		MOVWF	SPBRG		
		
		MOVLW 	B'00100000' 	;zapnuti TXEN
		MOVWF 	TXSTA			;
		CLRF 	PIE1 			;Vypnout preruseni na periferiich 
		BCF  	STATUS,RP0		;BANKA0
		
		BSF		RCSTA,SPEN		;POVOLENI SERIOVEHO PORTU
		BSF		RCSTA,CREN		;POVOLEN PRIJMU

;--------------------------------------------------------------------------------------------

SYNCHRO
		MOVLW	0x55
      	BTFSS	PIR1,TXIF     	;TESTOVANI ABYCHOM SI TXREG NEPREPSALI  vdy pred zpisom !
      	GOTO   	$-1				;
	    MOVWF	TXREG         	;presunout 8-bit hodnotu do registru TXREG (Bank0) => nacteni dat zacina vysilani

		BTFSC	RCSTA,OERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;	
		BTFSC	RCSTA,FERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;
		BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG) 1.POKUS
		CALL	DELAY5mS		;POKUD NE, TAK CEKEJ 5mS
		BTFSC	RCSTA,OERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;	
		BTFSC	RCSTA,FERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;
		BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG) 2.POKUS
		GOTO	SYNCHRO			;POKUD NE, TAK SYNCHRONIZUJ ZNOVU
		MOVF	RCREG,0			;NACTENI PRIJATYCH DAT
		MOVWF	TEMP			
		MOVLW   0XAA			
      	SUBWF   TEMP,0          ;porovnaj  ak W==VYBER>je zero v STATUS
      	BTFSC   STATUS,Z       	; Zero indikator
		GOTO	SYNCHRO
		GOTO	PRENOSK0
		
			
RESTARTPRIJMU
		BCF		RCSTA,4
		BSF		RCSTA,4
		GOTO	SYNCHRO

		
PRENOSK0
		
	
		MOVLW	B'00000001'		;ve W je ulozena informace a MCU ji odesila pres UART ven (KANAL 0)
		BTFSS	PIR1,TXIF     	;TESTOVANI ABYCHOM SI TXREG NEPREPSALI  vdy pred zpisom !
      	GOTO   	$-1				;
		MOVWF 	TXREG 			;presunout 8-bit hodnotu do registru TXREG (Bank0) => nacteni dat zacina vysilani

	
PRIJEM1
		BTFSC	RCSTA,OERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;	
		BTFSC	RCSTA,FERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;
		BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG) 1.POKUS
		CALL	DELAY5mS		;POKUD NE, TAK CEKEJ 5mS
		BTFSC	RCSTA,OERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;	
		BTFSC	RCSTA,FERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;
		BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG) 2.POKUS
		GOTO	PRENOSK0		;POKUD NE, TAK VYSLI POZADAVEK ZNOVU
		MOVF	RCREG,0
		MOVWF	K0L				;DAT A JEJICH ULOZENI
	
PRIJEM2
		BTFSC	RCSTA,OERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;	
		BTFSC	RCSTA,FERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;
		BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG) 1.POKUS
		CALL	DELAY5mS		;POKUD NE, TAK CEKEJ 5mS
		BTFSC	RCSTA,OERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;	
		BTFSC	RCSTA,FERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;
		BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG) 2.POKUS
		GOTO	PRENOSK0		;POKUD NE, TAK VYSLI POZADAVEK ZNOVU
		MOVF	RCREG,0
		MOVWF	K0H				;DAT A JEJICH ULOZENI
		
PRENOSK1
		
		MOVLW	B'00000010'		;ve W je ulozena informace a MCU ji odesila pres UART ven (KANAL 0)
		BTFSS	PIR1,TXIF     	;TESTOVANI ABYCHOM SI TXREG NEPREPSALI  vdy pred zpisom !
      	GOTO   	$-1				;
		MOVWF 	TXREG 			;presunout 8-bit hodnotu do registru TXREG (Bank0) => nacteni dat zacina vysilani
		
	
PRIJEM3
		BTFSC	RCSTA,OERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;	
		BTFSC	RCSTA,FERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;
		BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG) 1.POKUS
		CALL	DELAY5mS		;POKUD NE, TAK CEKEJ 5mS
		BTFSC	RCSTA,OERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;	
		BTFSC	RCSTA,FERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;
		BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG) 2.POKUS
		GOTO	PRENOSK1		;POKUD NE, TAK VYSLI POZADAVEK ZNOVU
		MOVF	RCREG,0
		MOVWF	K1L				;DAT A JEJICH ULOZENI
	
PRIJEM4
		BTFSC	RCSTA,OERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;	
		BTFSC	RCSTA,FERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;
		BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG) 1.POKUS
		CALL	DELAY5mS		;POKUD NE, TAK CEKEJ 5mS
		BTFSC	RCSTA,OERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;	
		BTFSC	RCSTA,FERR		;TEST CHYBY PRIJMU
		GOTO	RESTARTPRIJMU	;
		BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG) 2.POKUS
		GOTO	PRENOSK1		;POKUD NE, TAK VYSLI POZADAVEK ZNOVU
		MOVF	RCREG,0
		MOVWF	K1H				;DAT A JEJICH ULOZENI


		GOTO	PRENOSK0





		END


	